if (!defined &_CURSES_H) {
    eval 'sub _CURSES_H {1;}';
    require 'widec.ph';
    require 'stdio.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub CSMAX {4;}';
    if (defined &L_ctermid) {
	if (defined &SYSV) {
	}
	eval 'sub SYSV {1;}';
    }
    if (defined &BSD) {
    }
    if (defined &SYSV) {
	if (!defined &VINTR) {
	    require 'termio.ph';
	}
    }
    else {
	if (!defined &_SGTTYB_) {
	    require 'sgtty.ph';
	}
	eval 'sub memcpy {
	    local($dst, $src, $len) = @_;
	    eval " &bcopy(($src), ($dst), ($len))";
	}';
	eval 'sub strchr { &index;}';
	eval 'sub strrchr { &rindex;}';
    }
    eval 'sub _VR3_COMPAT_CODE {1;}';
    if (defined &CHTYPE) {
    }
    else {
    }
    if (defined &_VR3_COMPAT_CODE) {
    }
    if (!defined( &TRUE) || (( &TRUE) != 1)) {
	eval 'sub TRUE {(1);}';
    }
    if (!defined( &FALSE) || (( &FALSE) != 0)) {
	eval 'sub FALSE {(0);}';
    }
    if (!defined( &ERR) || (( &ERR) != -1)) {
	eval 'sub ERR {(-1);}';
    }
    if (!defined( &OK) || (( &OK) != 0)) {
	eval 'sub OK {(0);}';
    }
    if (defined &_VR3_COMPAT_CODE) {
    }
    eval 'sub _NOCHANGE {-1;}';
    eval 'sub _INFINITY {16000;}';
    eval 'sub _ISPAD {001;}';
    eval 'sub _WINCHANGED {002;}';
    eval 'sub _WINMOVED {004;}';
    eval 'sub _WINSDEL {010;}';
    eval 'sub _CANT_BE_IMMED {020;}';
    eval 'sub _WIN_ADD_ONE {040;}';
    eval 'sub _WIN_INS_ONE {100;}';
    eval 'sub CURS_STUPID {0;}';
    eval 'sub CURS_UNKNOWN {1;}';
    eval 'sub CURS_BAD_MALLOC {2;}';
    if (defined( &lint) && !defined( &CURSES) ) {
    }
    if (defined &_VR3_COMPAT_CODE) {
	eval 'sub initscr { &initscr32;}';
	eval 'sub newterm { &newterm32;}';
	eval 'sub waddch { &w32addch;}';
	eval 'sub wechochar { &w32echochar;}';
	eval 'sub pechochar { &p32echochar;}';
	eval 'sub winsch { &w32insch;}';
	eval 'sub vidputs { &vid32puts;}';
	eval 'sub vidattr { &vid32attr;}';
	eval 'sub wattroff { &w32attroff;}';
	eval 'sub wattron { &w32attron;}';
	eval 'sub wattrset { &w32attrset;}';
	eval 'sub acs_map { &acs32map;}';
	eval 'sub box { &box32;}';
	if (defined &__STDC__) {
	}
	else {
	}
	if (defined &__STDC__) {
	}
	else {
	}
    }
    else {
    }
    if (defined &__STDC__) {
    }
    else {
    }
    eval 'sub getsyx {
        local($y, $x) = @_;
        eval " &_getsyx(&($y), &($x))";
    }';
    eval 'sub getyx {
        local($win, $y, $x) = @_;
        eval "(($y) =  &getcury($win), ($x) =  &getcurx($win))";
    }';
    eval 'sub getbegyx {
        local($win, $y, $x) = @_;
        eval "(($y) =  &getbegy($win), ($x) =  &getbegx($win))";
    }';
    eval 'sub getmaxyx {
        local($win, $y, $x) = @_;
        eval "(($y) =  &getmaxy($win), ($x) =  &getmaxx($win))";
    }';
    eval 'sub getparyx {
        local($win, $y, $x) = @_;
        eval "(($y) =  &getpary($win), ($x) =  &getparx($win))";
    }';
    if (defined( &CURS_PERFORMANCE) && !defined( &lint)) {
	eval 'sub getcury {
	    local($win) = @_;
	    eval "(($win)-> &_cury)";
	}';
	eval 'sub getcurx {
	    local($win) = @_;
	    eval "(($win)-> &_curx)";
	}';
	eval 'sub getbegy {
	    local($win) = @_;
	    eval "(($win)-> &_begy)";
	}';
	eval 'sub getbegx {
	    local($win) = @_;
	    eval "(($win)-> &_begx)";
	}';
	eval 'sub getmaxy {
	    local($win) = @_;
	    eval "(($win)-> &_maxy)";
	}';
	eval 'sub getmaxx {
	    local($win) = @_;
	    eval "(($win)-> &_maxx)";
	}';
	eval 'sub getpary {
	    local($win) = @_;
	    eval "(($win)-> &_pary)";
	}';
	eval 'sub getparx {
	    local($win) = @_;
	    eval "(($win)-> &_parx)";
	}';
	eval 'sub getbkgd {
	    local($win) = @_;
	    eval "(($win)-> &_bkgd)";
	}';
	eval 'sub getattrs {
	    local($win) = @_;
	    eval "(($win)-> &_attrs)";
	}';
    }
    else {
	if (defined &__STDC__) {
	}
	else {
	}
    }
    if (defined( &NOMACROS) || defined( &lint)) {
	if (defined &__STDC__) {
	}
	else {
	}
    }
    else {
	require 'unctrl.ph';
	eval 'sub addch {
	    local($ch) = @_;
	    eval " &waddch( &stdscr, $ch)";
	}';
	eval 'sub addnstr {
	    local($s, $n) = @_;
	    eval " &waddnstr( &stdscr, $s, $n)";
	}';
	eval 'sub addstr {
	    local($str) = @_;
	    eval " &waddstr( &stdscr, $str)";
	}';
	eval 'sub attroff {
	    local($at) = @_;
	    eval " &wattroff( &stdscr, $at)";
	}';
	eval 'sub attron {
	    local($at) = @_;
	    eval " &wattron( &stdscr, $at)";
	}';
	eval 'sub attrset {
	    local($at) = @_;
	    eval " &wattrset( &stdscr, $at)";
	}';
	eval 'sub bkgd {
	    local($c) = @_;
	    eval " &wbkgd( &stdscr, $c)";
	}';
	eval 'sub border {
	    local($ls, $rs, $ts, $bs, $tl, $tr, $bl, $br) = @_;
	    eval " &wborder( &stdscr, $ls, $rs, $ts, $bs, $tl, $tr, $bl, $br)";
	}';
	eval 'sub clear {
	    eval " &wclear( &stdscr)";
	}';
	eval 'sub clrtobot {
	    eval " &wclrtobot( &stdscr)";
	}';
	eval 'sub clrtoeol {
	    eval " &wclrtoeol( &stdscr)";
	}';
	eval 'sub delch {
	    eval " &wdelch( &stdscr)";
	}';
	eval 'sub deleteln {
	    eval " &wdeleteln( &stdscr)";
	}';
	eval 'sub echochar {
	    local($ch) = @_;
	    eval " &wechochar( &stdscr, $ch)";
	}';
	eval 'sub erase {
	    eval " &werase( &stdscr)";
	}';
	eval 'sub getch {
	    eval " &wgetch( &stdscr)";
	}';
	eval 'sub getstr {
	    local($str) = @_;
	    eval " &wgetstr( &stdscr, $str)";
	}';
	eval 'sub inch {
	    eval " &winch( &stdscr)";
	}';
	eval 'sub insch {
	    local($c) = @_;
	    eval " &winsch( &stdscr, $c)";
	}';
	eval 'sub insdelln {
	    local($id) = @_;
	    eval " &winsdelln( &stdscr, $id)";
	}';
	eval 'sub insertln {
	    eval " &winsertln( &stdscr)";
	}';
	eval 'sub insnstr {
	    local($s, $n) = @_;
	    eval " &winsnstr( &stdscr, $s, $n)";
	}';
	eval 'sub insstr {
	    local($s) = @_;
	    eval " &winsstr( &stdscr, $s)";
	}';
	eval 'sub move {
	    local($y, $x) = @_;
	    eval " &wmove( &stdscr, $y, $x)";
	}';
	eval 'sub refresh {
	    eval " &wrefresh( &stdscr)";
	}';
	eval 'sub scrl {
	    local($n) = @_;
	    eval " &wscrl( &stdscr, $n)";
	}';
	eval 'sub setscrreg {
	    local($t, $b) = @_;
	    eval " &wsetscrreg( &stdscr, $t, $b)";
	}';
	eval 'sub standend {
	    eval " &wstandend( &stdscr)";
	}';
	eval 'sub standout {
	    eval " &wstandout( &stdscr)";
	}';
	eval 'sub timeout {
	    local($tm) = @_;
	    eval " &wtimeout( &stdscr, $tm)";
	}';
	eval 'sub hline {
	    local($c, $num) = @_;
	    eval " &whline( &stdscr, $c, $num)";
	}';
	eval 'sub vline {
	    local($c, $num) = @_;
	    eval " &wvline( &stdscr, $c, $num)";
	}';
	eval 'sub addchstr {
	    local($str) = @_;
	    eval " &waddchstr( &stdscr, $str)";
	}';
	eval 'sub addchnstr {
	    local($str, $n) = @_;
	    eval " &waddchnstr( &stdscr, $str, $n)";
	}';
	eval 'sub instr {
	    local($str) = @_;
	    eval " &winstr( &stdscr, ($str))";
	}';
	eval 'sub innstr {
	    local($str, $n) = @_;
	    eval " &winnstr( &stdscr, ($str), ($n))";
	}';
	eval 'sub inchstr {
	    local($str) = @_;
	    eval " &winchstr( &stdscr, $str)";
	}';
	eval 'sub inchnstr {
	    local($str, $n) = @_;
	    eval " &winchnstr( &stdscr, $str, $n)";
	}';
	eval 'sub bkgdset {
	    local($c) = @_;
	    eval " &wbkgdset( &stdscr, $c)";
	}';
	eval 'sub addnwstr {
	    local($ws, $n) = @_;
	    eval " &waddnwstr( &stdscr, $ws, $n)";
	}';
	eval 'sub addwch {
	    local($ch) = @_;
	    eval " &waddwch( &stdscr, $ch)";
	}';
	eval 'sub addwchnstr {
	    local($str, $n) = @_;
	    eval " &waddwchnstr( &stdscr, $str, $n)";
	}';
	eval 'sub addwchstr {
	    local($str) = @_;
	    eval " &waddwchstr( &stdscr, $str)";
	}';
	eval 'sub addwstr {
	    local($ws) = @_;
	    eval " &waddwstr( &stdscr, $ws)";
	}';
	eval 'sub echowchar {
	    local($ch) = @_;
	    eval " &wechowchar( &stdscr, $ch)";
	}';
	eval 'sub getnwstr {
	    local($ws, $n) = @_;
	    eval " &wgetnwstr( &stdscr, $ws, $n)";
	}';
	eval 'sub getwch {
	    eval " &wgetwch( &stdscr)";
	}';
	eval 'sub getwstr {
	    local($ws) = @_;
	    eval " &wgetwstr( &stdscr, $ws)";
	}';
	eval 'sub innwstr {
	    local($ws, $n) = @_;
	    eval " &winnwstr( &stdscr, $ws, $n)";
	}';
	eval 'sub insnwstr {
	    local($ws, $n) = @_;
	    eval " &winsnwstr( &stdscr, $ws, $n)";
	}';
	eval 'sub inswch {
	    local($c) = @_;
	    eval " &winswch( &stdscr, $c)";
	}';
	eval 'sub inswstr {
	    local($ws) = @_;
	    eval " &winswstr( &stdscr, $ws)";
	}';
	eval 'sub inwch {
	    eval " &winwch( &stdscr)";
	}';
	eval 'sub inwchnstr {
	    local($str, $n) = @_;
	    eval " &winwchnstr( &stdscr, $str, $n)";
	}';
	eval 'sub inwchstr {
	    local($str) = @_;
	    eval " &winwchstr( &stdscr, $str)";
	}';
	eval 'sub inwstr {
	    local($ws) = @_;
	    eval " &winwstr( &stdscr, $ws)";
	}';
	eval 'sub adjcurspos {
	    eval " &wadjcurspos( &stdscr)";
	}';
	eval 'sub movenextch {
	    eval " &wmovenextch( &stdscr)";
	}';
	eval 'sub moveprevch {
	    eval " &wmoveprevch( &stdscr)";
	}';
	if (defined &CURS_PERFORMANCE) {
	    eval 'sub wbkgdset {
	        local($win, $c) = @_;
	        eval "((($win)-> &_attrs = ((($win)-> &_attrs & ~(($win)-> &_bkgd &  &A_ATTRIBUTES)) | ($c &  &A_ATTRIBUTES))), (($win)-> &_bkgd = ($c)))";
	    }';
	    eval 'sub syncok {
	        local($win, $bf) = @_;
	        eval "(($win)-> &_parent ? ($win)-> &_sync = ($bf) :  &ERR)";
	    }';
	    eval 'sub notimeout {
	        local($win, $bf) = @_;
	        eval "((($win)-> &_notimeout = (($bf) ?  &TRUE :  &FALSE)),  &OK)";
	    }';
	    eval 'sub clearok {
	        local($win, $bf) = @_;
	        eval "((($win)-> &_clear = ($bf)),  &OK)";
	    }';
	    eval 'sub leaveok {
	        local($win, $bf) = @_;
	        eval "((($win)-> &_leave = ($bf)),  &OK)";
	    }';
	    eval 'sub scrollok {
	        local($win, $bf) = @_;
	        eval "((($win)-> &_scroll = (($bf) ?  &TRUE :  &FALSE)),  &OK)";
	    }';
	    eval 'sub idcok {
	        local($win, $bf) = @_;
	        eval "(($win)-> &_use_idc = (($bf) ?  &TRUE :  &FALSE))";
	    }';
	    eval 'sub nodelay {
	        local($win, $bf) = @_;
	        eval "((($win)-> &_delay = ($bf) ? 0 : -1),  &OK)";
	    }';
	    eval 'sub is_wintouched {
	        local($win) = @_;
	        eval "(($win)-> &_flags &  &_WINCHANGED)";
	    }';
	    eval 'sub is_linetouched {
	        local($win, $line) = @_;
	        eval "(((($line) >= ($win)-> &_maxy) || (($line) < 0)) ?  &ERR : ((($win)-> &_firstch[($line)] ==  &_INFINITY) ?  &FALSE :  &TRUE))";
	    }';
	    eval 'sub subwin {
	        local($win, $nl, $nc, $by, $bx) = @_;
	        eval " &derwin(($win), ($nl), ($nc), ($by-$win-> &_begy), ($bx-$win-> &_begx))";
	    }';
	    eval 'sub touchwin {
	        local($win) = @_;
	        eval " &wtouchln(($win), 0, ($win)-> &_maxy,  &TRUE)";
	    }';
	    eval 'sub redrawwin {
	        local($win) = @_;
	        eval " &wredrawln(($win), 0, ($win)-> &_maxy)";
	    }';
	    eval 'sub winchstr {
	        local($win, $str) = @_;
	        eval " &winchnstr(($win), $str, (($win)-> &_maxx - ($win)-> &_curx))";
	    }';
	    eval 'sub winstr {
	        local($win, $str) = @_;
	        eval " &winnstr(($win), $str, (($win)-> &_maxx - ($win)-> &_curx))";
	    }';
	    eval 'sub untouchwin {
	        local($win) = @_;
	        eval " &wtouchln(($win), 0, (($win)-> &_maxy),  &FALSE)";
	    }';
	    eval 'sub winch {
	        local($win) = @_;
	        eval "(($win)-> &_y[($win)-> &_cury][($win)-> &_curx])";
	    }';
	    eval 'sub wtimeout {
	        local($win, $tm) = @_;
	        eval "(($win)-> &_delay = ($tm))";
	    }';
	    eval 'sub use_env {
	        local($bf) = @_;
	        eval "( &_use_env = ($bf))";
	    }';
	}
	else {
	    if (defined &__STDC__) {
	    }
	    else {
	    }
	}
	eval 'sub mvaddch {
	    local($y, $x, $ch) = @_;
	    eval " &mvwaddch( &stdscr, $y, $x, $ch)";
	}';
	eval 'sub mvaddnstr {
	    local($y, $x, $s, $n) = @_;
	    eval " &mvwaddnstr( &stdscr, $y, $x, $s, $n)";
	}';
	eval 'sub mvaddstr {
	    local($y, $x, $str) = @_;
	    eval " &mvwaddstr( &stdscr, $y, $x, $str)";
	}';
	eval 'sub mvdelch {
	    local($y, $x) = @_;
	    eval " &mvwdelch( &stdscr, $y, $x)";
	}';
	eval 'sub mvgetch {
	    local($y, $x) = @_;
	    eval " &mvwgetch( &stdscr, $y, $x)";
	}';
	eval 'sub mvgetstr {
	    local($y, $x, $str) = @_;
	    eval " &mvwgetstr( &stdscr, $y, $x, $str)";
	}';
	eval 'sub mvinch {
	    local($y, $x) = @_;
	    eval " &mvwinch( &stdscr, $y, $x)";
	}';
	eval 'sub mvinsch {
	    local($y, $x, $c) = @_;
	    eval " &mvwinsch( &stdscr, $y, $x, $c)";
	}';
	eval 'sub mvinsnstr {
	    local($y, $x, $s, $n) = @_;
	    eval " &mvwinsnstr( &stdscr, $y, $x, $s, $n)";
	}';
	eval 'sub mvinsstr {
	    local($y, $x, $s) = @_;
	    eval " &mvwinsstr( &stdscr, $y, $x, $s)";
	}';
	eval 'sub mvaddchstr {
	    local($y, $x, $str) = @_;
	    eval " &mvwaddchstr( &stdscr, $y, $x, $str)";
	}';
	eval 'sub mvaddchnstr {
	    local($y, $x, $str, $n) = @_;
	    eval " &mvwaddchnstr( &stdscr, $y, $x, $str, $n)";
	}';
	eval 'sub mvinstr {
	    local($y, $x, $str) = @_;
	    eval " &mvwinstr( &stdscr, $y, $x, ($str))";
	}';
	eval 'sub mvinnstr {
	    local($y, $x, $str, $n) = @_;
	    eval " &mvwinnstr( &stdscr, $y, $x, ($str), ($n))";
	}';
	eval 'sub mvinchstr {
	    local($y, $x, $str) = @_;
	    eval " &mvwinchstr( &stdscr, $y, $x, $str)";
	}';
	eval 'sub mvinchnstr {
	    local($y, $x, $str, $n) = @_;
	    eval " &mvwinchnstr( &stdscr, $y, $x, $str, $n)";
	}';
	eval 'sub mvhline {
	    local($y, $x, $c, $num) = @_;
	    eval " &mvwhline( &stdscr, $y, $x, $c, $num)";
	}';
	eval 'sub mvvline {
	    local($y, $x, $c, $num) = @_;
	    eval " &mvwvline( &stdscr, $y, $x, $c, $num)";
	}';
	eval 'sub mvaddnwstr {
	    local($y, $x, $ws, $n) = @_;
	    eval " &mvwaddnwstr( &stdscr, $y, $x, $ws, $n)";
	}';
	eval 'sub mvaddwch {
	    local($y, $x, $ch) = @_;
	    eval " &mvwaddwch( &stdscr, $y, $x, $ch)";
	}';
	eval 'sub mvaddwchnstr {
	    local($y, $x, $str, $n) = @_;
	    eval " &mvwaddwchnstr( &stdscr, $y, $x, $str, $n)";
	}';
	eval 'sub mvaddwchstr {
	    local($y, $x, $str) = @_;
	    eval " &mvwaddwchstr( &stdscr, $y, $x, $str)";
	}';
	eval 'sub mvaddwstr {
	    local($y, $x, $ws) = @_;
	    eval " &mvwaddwstr( &stdscr, $y, $x, $ws)";
	}';
	eval 'sub mvgetnwstr {
	    local($y, $x, $ws, $n) = @_;
	    eval " &mvwgetnwstr( &stdscr, $y, $x, $ws, $n)";
	}';
	eval 'sub mvgetwch {
	    local($y, $x) = @_;
	    eval " &mvwgetwch( &stdscr, $y, $x)";
	}';
	eval 'sub mvgetwstr {
	    local($y, $x, $ws) = @_;
	    eval " &mvwgetwstr( &stdscr, $y, $x, $ws)";
	}';
	eval 'sub mvinnwstr {
	    local($y, $x, $ws, $n) = @_;
	    eval " &mvwinnwstr( &stdscr, $y, $x, $ws, $n)";
	}';
	eval 'sub mvinsnwstr {
	    local($y, $x, $ws, $n) = @_;
	    eval " &mvwinsnwstr( &stdscr, $y, $x, $ws, $n)";
	}';
	eval 'sub mvinswch {
	    local($y, $x, $c) = @_;
	    eval " &mvwinswch( &stdscr, $y, $x, $c)";
	}';
	eval 'sub mvinswstr {
	    local($y, $x, $ws) = @_;
	    eval " &mvwinswstr( &stdscr, $y, $x, $ws)";
	}';
	eval 'sub mvinwch {
	    local($y, $x) = @_;
	    eval " &mvwinwch( &stdscr, $y, $x)";
	}';
	eval 'sub mvinwchnstr {
	    local($y, $x, $str, $n) = @_;
	    eval " &mvwinwchnstr( &stdscr, $y, $x, $str, $n)";
	}';
	eval 'sub mvinwchstr {
	    local($y, $x, $str) = @_;
	    eval " &mvwinwchstr( &stdscr, $y, $x, $str)";
	}';
	eval 'sub mvinwstr {
	    local($y, $x, $ws) = @_;
	    eval " &mvwinwstr( &stdscr, $y, $x, $ws)";
	}';
	eval 'sub mvwaddch {
	    local($win, $y, $x, $ch) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &waddch($win, $ch))";
	}';
	eval 'sub mvwaddnstr {
	    local($win, $y, $x, $s, $n) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &waddnstr($win, $s, $n))";
	}';
	eval 'sub mvwaddstr {
	    local($win, $y, $x, $str) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &waddstr($win, $str))";
	}';
	eval 'sub mvwdelch {
	    local($win, $y, $x) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &wdelch($win))";
	}';
	eval 'sub mvwgetch {
	    local($win, $y, $x) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &wgetch($win))";
	}';
	eval 'sub mvwgetstr {
	    local($win, $y, $x, $str) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &wgetstr($win, $str))";
	}';
	eval 'sub mvwinch {
	    local($win, $y, $x) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ? ( &chtype) &ERR :  &winch($win))";
	}';
	eval 'sub mvwinsch {
	    local($win, $y, $x, $c) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winsch($win, $c))";
	}';
	eval 'sub mvwinsnstr {
	    local($win, $y, $x, $s, $n) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winsnstr($win, $s, $n))";
	}';
	eval 'sub mvwinsstr {
	    local($win, $y, $x, $s) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winsstr($win, $s))";
	}';
	eval 'sub mvwhline {
	    local($win, $y, $x, $c, $num) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &whline($win, $c, $num))";
	}';
	eval 'sub mvwvline {
	    local($win, $y, $x, $c, $num) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &wvline($win, $c, $num))";
	}';
	eval 'sub mvwaddchstr {
	    local($win, $y, $x, $str) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &waddchstr($win, $str))";
	}';
	eval 'sub mvwaddchnstr {
	    local($win, $y, $x, $str, $n) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &waddchnstr($win, $str, $n))";
	}';
	eval 'sub mvwinstr {
	    local($win, $y, $x, $str) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winstr($win, $str))";
	}';
	eval 'sub mvwinnstr {
	    local($win, $y, $x, $str, $n) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winnstr($win, $str, $n))";
	}';
	eval 'sub mvwinchstr {
	    local($win, $y, $x, $str) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winchstr($win, $str))";
	}';
	eval 'sub mvwinchnstr {
	    local($win, $y, $x, $str, $n) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winchnstr($win, $str, $n))";
	}';
	eval 'sub mvwaddnwstr {
	    local($win, $y, $x, $ws, $n) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &waddnwstr($win, $ws, $n))";
	}';
	eval 'sub mvwaddwch {
	    local($win, $y, $x, $ch) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &waddwch($win, $ch))";
	}';
	eval 'sub mvwaddwchnstr {
	    local($win, $y, $x, $str, $n) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &waddwchnstr($win, $str, $n))";
	}';
	eval 'sub mvwaddwchstr {
	    local($win, $y, $x, $str) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &waddwchstr($win, $str))";
	}';
	eval 'sub mvwaddwstr {
	    local($win, $y, $x, $ws) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &waddwstr($win, $ws))";
	}';
	eval 'sub mvwgetnwstr {
	    local($win, $y, $x, $ws, $n) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &wgetnwstr($win, $ws, $n))";
	}';
	eval 'sub mvwgetwch {
	    local($win, $y, $x) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &wgetwch($win))";
	}';
	eval 'sub mvwgetwstr {
	    local($win, $y, $x, $ws) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &wgetwstr($win, $ws))";
	}';
	eval 'sub mvwinnwstr {
	    local($win, $y, $x, $ws, $n) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winnwstr($win, $ws, $n))";
	}';
	eval 'sub mvwinsnwstr {
	    local($win, $y, $x, $ws, $n) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winsnwstr($win, $ws, $n))";
	}';
	eval 'sub mvwinswch {
	    local($win, $y, $x, $c) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winswch($win, $c))";
	}';
	eval 'sub mvwinswstr {
	    local($win, $y, $x, $ws) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winswstr($win, $ws))";
	}';
	eval 'sub mvwinwch {
	    local($win, $y, $x) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?( &chtype)  &ERR :  &winwch($win))";
	}';
	eval 'sub mvwinwchnstr {
	    local($win, $y, $x, $str, $n) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winwchnstr($win, $str, $n))";
	}';
	eval 'sub mvwinwchstr {
	    local($win, $y, $x, $str) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winwchstr($win, $str))";
	}';
	eval 'sub mvwinwstr {
	    local($win, $y, $x, $ws) = @_;
	    eval "( &wmove($win, $y, $x) ==  &ERR ?  &ERR :  &winwstr($win, $ws))";
	}';
	eval 'sub waddwchstr {
	    local($win, $str) = @_;
	    eval " &waddwchnstr($win, $str, -1)";
	}';
	eval 'sub winwchstr {
	    local($win, $str) = @_;
	    eval " &winwchnstr($win, $str, -1)";
	}';
	eval 'sub waddwstr {
	    local($win, $ws) = @_;
	    eval " &waddnwstr($win, $ws, -1)";
	}';
	eval 'sub winswstr {
	    local($win, $ws) = @_;
	    eval " &winsnwstr($win, $ws, -1)";
	}';
	if (defined &CURS_MACROS) {
	    eval 'sub overlay {
	        local($src, $dst) = @_;
	        eval " &_overlap(($src), ($dst),  &TRUE)";
	    }';
	    eval 'sub overwrite {
	        local($src, $dst) = @_;
	        eval " &_overlap(($src), ($dst),  &FALSE)";
	    }';
	    eval 'sub wdeleteln {
	        local($win) = @_;
	        eval " &winsdelln(($win), -1)";
	    }';
	    eval 'sub winsertln {
	        local($win) = @_;
	        eval " &winsdelln(($win), 1)";
	    }';
	    eval 'sub wstandend {
	        local($win) = @_;
	        eval " &wattrset(($win),  &A_NORMAL)";
	    }';
	    eval 'sub wstandout {
	        local($win) = @_;
	        eval " &wattron(($win),  &A_STANDOUT)";
	    }';
	    eval 'sub beep {
	        eval " &_ring( &TRUE)";
	    }';
	    eval 'sub flash {
	        eval " &_ring( &FALSE)";
	    }';
	    eval 'sub scroll {
	        local($win) = @_;
	        eval " &wscrl(($win), 1)";
	    }';
	    eval 'sub slk_init {
	        local($f) = @_;
	        eval " &slk_start((($f == 0) ? 3 : 2),  &NULL)";
	    }';
	    eval 'sub scr_init {
	        local($file) = @_;
	        eval " &_scr_all($file, 0)";
	    }';
	    eval 'sub scr_restore {
	        local($file) = @_;
	        eval " &_scr_all($file, 1)";
	    }';
	    eval 'sub scr_set {
	        local($file) = @_;
	        eval " &_scr_all($file, 2)";
	    }';
	    eval 'sub subpad {
	        local($win, $nl, $nc, $by, $bx) = @_;
	        eval " &derwin(($win), ($nl), ($nc), ($by), ($bx))";
	    }';
	    eval 'sub box {
	        local($win, $v, $h) = @_;
	        eval " &wborder(($win), ($v), ($v), ($h), ($h), 0, 0, 0, 0)";
	    }';
	    eval 'sub newterm {
	        local($type, $fout, $fin) = @_;
	        eval " &newscreen(($type), 0, 0, 0, ($fout), ($fin))";
	    }';
	    eval 'sub touchline {
	        local($win, $y, $n) = @_;
	        eval " &wtouchln(($win), ($y), ($n),  &TRUE)";
	    }';
	    eval 'sub waddstr {
	        local($win, $str) = @_;
	        eval " &waddnstr(($win), ($str), -1)";
	    }';
	    eval 'sub werase {
	        local($win) = @_;
	        eval "( &wmove(($win), 0, 0),  &wclrtobot($win))";
	    }';
	    eval 'sub wclear {
	        local($win) = @_;
	        eval "( &clearok(($win),  &TRUE),  &werase($win))";
	    }';
	    eval 'sub intrflush {
	        local($win, $flag) = @_;
	        eval " &_setqiflush($flag)";
	    }';
	    eval 'sub meta {
	        local($win, $flag) = @_;
	        eval " &_meta($flag)";
	    }';
	    eval 'sub setterm {
	        local($name) = @_;
	        eval " &setupterm(($name), 1,  &NULL)";
	    }';
	    eval 'sub gettmode {
	        eval "( &OK)";
	    }';
	    eval 'sub halfdelay {
	        local($tens) = @_;
	        eval " &ttimeout(($tens)*100)";
	    }';
	    eval 'sub echo {
	        eval " &_setecho( &TRUE)";
	    }';
	    eval 'sub noecho {
	        eval " &_setecho( &FALSE)";
	    }';
	    eval 'sub nl {
	        eval " &_setnonl( &FALSE)";
	    }';
	    eval 'sub nonl {
	        eval " &_setnonl( &TRUE)";
	    }';
	}
	else {
	    if (defined &__STDC__) {
	    }
	    else {
	    }
	}
	eval 'sub garbagedlines { &wredrawln;}';
	eval 'sub garbagedwin { &redrawwin;}';
	eval 'sub crmode { &cbreak;}';
	eval 'sub nocrmode { &nocbreak;}';
	eval 'sub saveterm { &def_prog_mode;}';
	eval 'sub fixterm { &reset_prog_mode;}';
	eval 'sub resetterm { &reset_shell_mode;}';
	eval 'sub waddchstr {
	    local($win, $str) = @_;
	    eval " &waddchnstr(($win), ($str), -1)";
	}';
	eval 'sub winsstr {
	    local($win, $str) = @_;
	    eval " &winsnstr(($win), ($str), -1)";
	}';
	eval 'sub qiflush {
	    eval " &_setqiflush( &TRUE)";
	}';
	eval 'sub noqiflush {
	    eval " &_setqiflush( &FALSE)";
	}';
	eval 'sub set_term { &setcurscreen;}';
    }
    eval 'sub ACS_BSSB {( &acs_map[ord(\'l\')]);}';
    eval 'sub ACS_SSBB {( &acs_map[ord(\'m\')]);}';
    eval 'sub ACS_BBSS {( &acs_map[ord(\'k\')]);}';
    eval 'sub ACS_SBBS {( &acs_map[ord(\'j\')]);}';
    eval 'sub ACS_SBSS {( &acs_map[ord(\'u\')]);}';
    eval 'sub ACS_SSSB {( &acs_map[ord(\'t\')]);}';
    eval 'sub ACS_SSBS {( &acs_map[ord(\'v\')]);}';
    eval 'sub ACS_BSSS {( &acs_map[ord(\'w\')]);}';
    eval 'sub ACS_BSBS {( &acs_map[ord(\'q\')]);}';
    eval 'sub ACS_SBSB {( &acs_map[ord(\'x\')]);}';
    eval 'sub ACS_SSSS {( &acs_map[ord(\'n\')]);}';
    eval 'sub ACS_ULCORNER { &ACS_BSSB;}';
    eval 'sub ACS_LLCORNER { &ACS_SSBB;}';
    eval 'sub ACS_URCORNER { &ACS_BBSS;}';
    eval 'sub ACS_LRCORNER { &ACS_SBBS;}';
    eval 'sub ACS_RTEE { &ACS_SBSS;}';
    eval 'sub ACS_LTEE { &ACS_SSSB;}';
    eval 'sub ACS_BTEE { &ACS_SSBS;}';
    eval 'sub ACS_TTEE { &ACS_BSSS;}';
    eval 'sub ACS_HLINE { &ACS_BSBS;}';
    eval 'sub ACS_VLINE { &ACS_SBSB;}';
    eval 'sub ACS_PLUS { &ACS_SSSS;}';
    eval 'sub ACS_S1 {( &acs_map[ord(\'o\')]);}';
    eval 'sub ACS_S9 {( &acs_map[ord(\'s\')]);}';
    eval 'sub ACS_DIAMOND {( &acs_map[ord(\'`\')]);}';
    eval 'sub ACS_CKBOARD {( &acs_map[ord(\'a\')]);}';
    eval 'sub ACS_DEGREE {( &acs_map[ord(\'f\')]);}';
    eval 'sub ACS_PLMINUS {( &acs_map[ord(\'g\')]);}';
    eval 'sub ACS_BULLET {( &acs_map[ord(\'~\')]);}';
    eval 'sub ACS_LARROW {( &acs_map[ord(\',\')]);}';
    eval 'sub ACS_RARROW {( &acs_map[ord(\'+\')]);}';
    eval 'sub ACS_DARROW {( &acs_map[ord(\'.\')]);}';
    eval 'sub ACS_UARROW {( &acs_map[ord(\'-\')]);}';
    eval 'sub ACS_BOARD {( &acs_map[ord(\'h\')]);}';
    eval 'sub ACS_LANTERN {( &acs_map[ord(\'i\')]);}';
    eval 'sub ACS_BLOCK {( &acs_map[ord(\'0\')]);}';
    eval 'sub KEY_MIN {0401;}';
    eval 'sub KEY_BREAK {0401;}';
    eval 'sub KEY_DOWN {0402;}';
    eval 'sub KEY_UP {0403;}';
    eval 'sub KEY_LEFT {0404;}';
    eval 'sub KEY_RIGHT {0405;}';
    eval 'sub KEY_HOME {0406;}';
    eval 'sub KEY_BACKSPACE {0407;}';
    eval 'sub KEY_F0 {0410;}';
    eval 'sub KEY_F {
        local($n) = @_;
        eval "( &KEY_F0+($n))";
    }';
    eval 'sub KEY_DL {0510;}';
    eval 'sub KEY_IL {0511;}';
    eval 'sub KEY_DC {0512;}';
    eval 'sub KEY_IC {0513;}';
    eval 'sub KEY_EIC {0514;}';
    eval 'sub KEY_CLEAR {0515;}';
    eval 'sub KEY_EOS {0516;}';
    eval 'sub KEY_EOL {0517;}';
    eval 'sub KEY_SF {0520;}';
    eval 'sub KEY_SR {0521;}';
    eval 'sub KEY_NPAGE {0522;}';
    eval 'sub KEY_PPAGE {0523;}';
    eval 'sub KEY_STAB {0524;}';
    eval 'sub KEY_CTAB {0525;}';
    eval 'sub KEY_CATAB {0526;}';
    eval 'sub KEY_ENTER {0527;}';
    eval 'sub KEY_SRESET {0530;}';
    eval 'sub KEY_RESET {0531;}';
    eval 'sub KEY_PRINT {0532;}';
    eval 'sub KEY_LL {0533;}';
    eval 'sub KEY_A1 {0534;}';
    eval 'sub KEY_A3 {0535;}';
    eval 'sub KEY_B2 {0536;}';
    eval 'sub KEY_C1 {0537;}';
    eval 'sub KEY_C3 {0540;}';
    eval 'sub KEY_BTAB {0541;}';
    eval 'sub KEY_BEG {0542;}';
    eval 'sub KEY_CANCEL {0543;}';
    eval 'sub KEY_CLOSE {0544;}';
    eval 'sub KEY_COMMAND {0545;}';
    eval 'sub KEY_COPY {0546;}';
    eval 'sub KEY_CREATE {0547;}';
    eval 'sub KEY_END {0550;}';
    eval 'sub KEY_EXIT {0551;}';
    eval 'sub KEY_FIND {0552;}';
    eval 'sub KEY_HELP {0553;}';
    eval 'sub KEY_MARK {0554;}';
    eval 'sub KEY_MESSAGE {0555;}';
    eval 'sub KEY_MOVE {0556;}';
    eval 'sub KEY_NEXT {0557;}';
    eval 'sub KEY_OPEN {0560;}';
    eval 'sub KEY_OPTIONS {0561;}';
    eval 'sub KEY_PREVIOUS {0562;}';
    eval 'sub KEY_REDO {0563;}';
    eval 'sub KEY_REFERENCE {0564;}';
    eval 'sub KEY_REFRESH {0565;}';
    eval 'sub KEY_REPLACE {0566;}';
    eval 'sub KEY_RESTART {0567;}';
    eval 'sub KEY_RESUME {0570;}';
    eval 'sub KEY_SAVE {0571;}';
    eval 'sub KEY_SBEG {0572;}';
    eval 'sub KEY_SCANCEL {0573;}';
    eval 'sub KEY_SCOMMAND {0574;}';
    eval 'sub KEY_SCOPY {0575;}';
    eval 'sub KEY_SCREATE {0576;}';
    eval 'sub KEY_SDC {0577;}';
    eval 'sub KEY_SDL {0600;}';
    eval 'sub KEY_SELECT {0601;}';
    eval 'sub KEY_SEND {0602;}';
    eval 'sub KEY_SEOL {0603;}';
    eval 'sub KEY_SEXIT {0604;}';
    eval 'sub KEY_SFIND {0605;}';
    eval 'sub KEY_SHELP {0606;}';
    eval 'sub KEY_SHOME {0607;}';
    eval 'sub KEY_SIC {0610;}';
    eval 'sub KEY_SLEFT {0611;}';
    eval 'sub KEY_SMESSAGE {0612;}';
    eval 'sub KEY_SMOVE {0613;}';
    eval 'sub KEY_SNEXT {0614;}';
    eval 'sub KEY_SOPTIONS {0615;}';
    eval 'sub KEY_SPREVIOUS {0616;}';
    eval 'sub KEY_SPRINT {0617;}';
    eval 'sub KEY_SREDO {0620;}';
    eval 'sub KEY_SREPLACE {0621;}';
    eval 'sub KEY_SRIGHT {0622;}';
    eval 'sub KEY_SRSUME {0623;}';
    eval 'sub KEY_SSAVE {0624;}';
    eval 'sub KEY_SSUSPEND {0625;}';
    eval 'sub KEY_SUNDO {0626;}';
    eval 'sub KEY_SUSPEND {0627;}';
    eval 'sub KEY_UNDO {0630;}';
    eval 'sub KEY_MOUSE {0631;}';
    eval 'sub KEY_MAX {0777;}';
    eval 'sub reg { &register;}';
    eval 'sub A_STANDOUT {000010000000 &L;}';
    eval 'sub _STANDOUT { &A_STANDOUT;}';
    eval 'sub A_UNDERLINE {000020000000 &L;}';
    eval 'sub A_REVERSE {000040000000 &L;}';
    eval 'sub A_BLINK {000100000000 &L;}';
    eval 'sub A_DIM {000200000000 &L;}';
    eval 'sub A_BOLD {000400000000 &L;}';
    eval 'sub A_ALTCHARSET {001000000000 &L;}';
    eval 'sub A_INVIS {010000000000 &L;}';
    eval 'sub A_PROTECT {020000000000 &L;}';
    eval 'sub A_NORMAL {000000000000 &L;}';
    eval 'sub A_ATTRIBUTES {031777700000 &L;}';
    eval 'sub A_CHARTEXT {006000077777 &L;}';
    eval 'sub A_COLOR {000007700000 &L;}';
    eval 'sub A_WATTRIBUTES {031770000000 &L;}';
    eval 'sub A_WCHARTEXT {006007777777 &L;}';
    eval 'sub COLOR_PAIR {
        local($n) = @_;
        eval "(($n) << 15)";
    }';
    eval 'sub PAIR_NUMBER {
        local($n) = @_;
        eval "((($n) &  &A_COLOR) >> 15)";
    }';
    eval 'sub COLOR_BLACK {0;}';
    eval 'sub COLOR_RED {1;}';
    eval 'sub COLOR_GREEN {2;}';
    eval 'sub COLOR_YELLOW {3;}';
    eval 'sub COLOR_BLUE {4;}';
    eval 'sub COLOR_MAGENTA {5;}';
    eval 'sub COLOR_CYAN {6;}';
    eval 'sub COLOR_WHITE {7;}';
    eval 'sub BUTTON_RELEASED {0;}';
    eval 'sub BUTTON_PRESSED {1;}';
    eval 'sub BUTTON_CLICKED {2;}';
    eval 'sub BUTTON_DOUBLE_CLICKED {3;}';
    eval 'sub BUTTON_TRIPLE_CLICKED {4;}';
    eval 'sub MOUSE_X_POS {( &Mouse_status. &x);}';
    eval 'sub MOUSE_Y_POS {( &Mouse_status. &y);}';
    eval 'sub A_BUTTON_CHANGED {( &Mouse_status. &changes & 7);}';
    eval 'sub MOUSE_MOVED {( &Mouse_status. &changes & 8);}';
    eval 'sub MOUSE_POS_REPORT {( &Mouse_status. &changes & 16);}';
    eval 'sub BUTTON_CHANGED {
        local($x) = @_;
        eval "( &Mouse_status. &changes & (1 << (($x) - 1)))";
    }';
    eval 'sub BUTTON_STATUS {
        local($x) = @_;
        eval "( &Mouse_status. &button[($x)-1])";
    }';
    eval 'sub BUTTON1_RELEASED {000000000001 &L;}';
    eval 'sub BUTTON1_PRESSED {000000000002 &L;}';
    eval 'sub BUTTON1_CLICKED {000000000004 &L;}';
    eval 'sub BUTTON1_DOUBLE_CLICKED {000000000010 &L;}';
    eval 'sub BUTTON1_TRIPLE_CLICKED {000000000020 &L;}';
    eval 'sub BUTTON2_RELEASED {000000000040 &L;}';
    eval 'sub BUTTON2_PRESSED {000000000100 &L;}';
    eval 'sub BUTTON2_CLICKED {000000000200 &L;}';
    eval 'sub BUTTON2_DOUBLE_CLICKED {000000000400 &L;}';
    eval 'sub BUTTON2_TRIPLE_CLICKED {000000001000 &L;}';
    eval 'sub BUTTON3_RELEASED {000000002000 &L;}';
    eval 'sub BUTTON3_PRESSED {000000004000 &L;}';
    eval 'sub BUTTON3_CLICKED {000000010000 &L;}';
    eval 'sub BUTTON3_DOUBLE_CLICKED {000000020000 &L;}';
    eval 'sub BUTTON3_TRIPLE_CLICKED {000000040000 &L;}';
    eval 'sub ALL_MOUSE_EVENTS {000000077777 &L;}';
    eval 'sub REPORT_MOUSE_POSITION {000000100000 &L;}';
    if (defined &__cplusplus) {
    }
}
1;
