if (!defined &_SYS_SOCKETVAR_H) {
    eval 'sub _SYS_SOCKETVAR_H {1;}';
    if (defined &__cplusplus) {
    }
    eval 'sub SB_MAX {(64*1024);}';
    eval 'sub SB_LOCK {0x01;}';
    eval 'sub SB_WANT {0x02;}';
    eval 'sub SB_WAIT {0x04;}';
    eval 'sub SB_SEL {0x08;}';
    eval 'sub SB_COLL {0x10;}';
    eval 'sub SS_NOFDREF {0x001;}';
    eval 'sub SS_ISCONNECTED {0x002;}';
    eval 'sub SS_ISCONNECTING {0x004;}';
    eval 'sub SS_ISDISCONNECTING {0x008;}';
    eval 'sub SS_CANTSENDMORE {0x010;}';
    eval 'sub SS_CANTRCVMORE {0x020;}';
    eval 'sub SS_RCVATMARK {0x040;}';
    eval 'sub SS_ISBOUND {0x080;}';
    eval 'sub SS_PRIV {0x080;}';
    eval 'sub SS_NBIO {0x100;}';
    eval 'sub SS_ASYNC {0x200;}';
    eval 'sub sbspace {
        local($sb) = @_;
        eval "( &MIN((($sb)-> &sb_hiwat - ($sb)-> &sb_cc), (($sb)-> &sb_mbmax - ($sb)-> &sb_mbcnt)))";
    }';
    eval 'sub sosendallatonce {
        local($so) = @_;
        eval "(($so)-> &so_proto-> &pr_flags &  &PR_ATOMIC)";
    }';
    eval 'sub soreadable {
        local($so) = @_;
        eval "(($so)-> &so_rcv. &sb_cc || (($so)-> &so_state &  &SS_CANTRCVMORE) || ($so)-> &so_qlen || ($so)-> &so_error)";
    }';
    eval 'sub sowriteable {
        local($so) = @_;
        eval "( &sbspace(&($so)-> &so_snd) > 0 && ((($so)-> &so_state& &SS_ISCONNECTED) || (($so)-> &so_proto-> &pr_flags& &PR_CONNREQUIRED) == 0) || (($so)-> &so_state &  &SS_CANTSENDMORE) || ($so)-> &so_error)";
    }';
    eval 'sub sballoc {
        local($sb, $m) = @_;
        eval "{ ($sb)-> &sb_cc += ($m)-> &m_len; ($sb)-> &sb_mbcnt +=  &MSIZE;  &if (($m)-> &m_off >  &MMAXOFF) ($sb)-> &sb_mbcnt +=  &MCLBYTES; }";
    }';
    eval 'sub sbfree {
        local($sb, $m) = @_;
        eval "{ ($sb)-> &sb_cc -= ($m)-> &m_len; ($sb)-> &sb_mbcnt -=  &MSIZE;  &if (($m)-> &m_off >  &MMAXOFF) ($sb)-> &sb_mbcnt -=  &MCLBYTES; }";
    }';
    eval 'sub sblock {
        local($so, $sb) = @_;
        eval "{  &while (($sb)-> &sb_flags &  &SB_LOCK) { ($sb)-> &sb_flags |=  &SB_WANT; ( &void)  &sleep(( &caddr_t)&($sb)-> &sb_flags,  &PZERO+1); } ($sb)-> &sb_flags |=  &SB_LOCK; }";
    }';
    eval 'sub sbunlock {
        local($so, $sb) = @_;
        eval "{ ($sb)-> &sb_flags &= ~ &SB_LOCK;  &if (($sb)-> &sb_flags &  &SB_WANT) { ($sb)-> &sb_flags &= ~ &SB_WANT;  &if (($so)-> &so_wupalt) (*($so)-> &so_wupalt-> &wup_func)($so, ( &caddr_t)&($sb)-> &sb_flags, ($so)-> &so_wupalt-> &wup_arg);  &else  &wakeup(( &caddr_t)&($sb)-> &sb_flags); } }";
    }';
    eval 'sub sorwakeup {
        local($so) = @_;
        eval " &sowakeup(($so), &($so)-> &so_rcv)";
    }';
    eval 'sub sowwakeup {
        local($so) = @_;
        eval " &sowakeup(($so), &($so)-> &so_snd)";
    }';
    if (defined &_KERNEL) {
    }
    if (defined &__cplusplus) {
    }
}
1;
