if (!defined &_SYS_THREAD_H) {
    eval 'sub _SYS_THREAD_H {1;}';
    require 'sys/types.ph';
    require 'sys/t_lock.ph';
    require 'sys/class.ph';
    require 'sys/klwp.ph';
    require 'sys/pirec.ph';
    require 'sys/sleepq.ph';
    require 'sys/turnstile.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub TS_FREE {0x00;}';
    eval 'sub TS_SLEEP {0x01;}';
    eval 'sub TS_RUN {0x02;}';
    eval 'sub TS_ONPROC {0x04;}';
    eval 'sub TS_ZOMB {0x08;}';
    eval 'sub TS_STOPPED {0x10;}';
    eval 'sub t_astflag { &_tu. &_ts. &_t_astflag;}';
    eval 'sub t_sig_check { &_tu. &_ts. &_t_sig_check;}';
    eval 'sub t_post_sys { &_tu. &_ts. &_t_post_sys;}';
    eval 'sub t_trapret { &_tu. &_ts. &_t_trapret;}';
    eval 'sub t_post_sys_ast { &_tu. &_t_post_sys_ast;}';
    if (defined &__DOS_EMUL) {
    }
    eval 'sub T_INTR_THREAD {0x0001;}';
    eval 'sub T_WAKEABLE {0x0002;}';
    eval 'sub T_TOMASK {0x0004;}';
    eval 'sub T_TALLOCSTK {0x0008;}';
    eval 'sub T_LWPZOMB {0x0010;}';
    eval 'sub T_WOULDBLOCK {0x0020;}';
    eval 'sub T_DONTBLOCK {0x0040;}';
    eval 'sub T_DONTPEND {0x0080;}';
    eval 'sub T_SYS_PROF {0x0100;}';
    eval 'sub T_WAITCVSEM {0x0200;}';
    eval 'sub TP_WAITFOR {0x01;}';
    eval 'sub TP_HOLDLWP {0x02;}';
    eval 'sub TP_TWAIT {0x04;}';
    eval 'sub TP_LWPEXIT {0x08;}';
    eval 'sub TP_PRSTOP {0x10;}';
    eval 'sub TP_CHKPT {0x20;}';
    eval 'sub TP_EXITLWP {0x40;}';
    eval 'sub TP_PRVSTOP {0x80;}';
    eval 'sub TP_MSACCT {0x100;}';
    eval 'sub TP_STOPPING {0x200;}';
    eval 'sub TS_LOAD {0x01;}';
    eval 'sub TS_CSTART {0x02;}';
    eval 'sub TS_XSTART {0x04;}';
    eval 'sub TS_PSTART {0x08;}';
    eval 'sub TS_DONT_SWAP {0x10;}';
    eval 'sub TS_RESUME {0x20;}';
    eval 'sub TS_SWAPENQ {0x40;}';
    eval 'sub TS_ON_SWAPQ {0x80;}';
    eval 'sub TS_ALLSTART {( &TS_CSTART |  &TS_XSTART |  &TS_PSTART |  &TS_RESUME);}';
    eval 'sub aston {
        local($t) = @_;
        eval "(($t)-> &t_astflag = 1)";
    }';
    eval 'sub astoff {
        local($t) = @_;
        eval "(($t)-> &t_astflag = 0)";
    }';
    eval 'sub ISTOPPED {
        local($t) = @_;
        eval "(($t)-> &t_state ==  &TS_STOPPED && !(($t)-> &t_schedflag &  &TS_PSTART))";
    }';
    eval 'sub CPR_ISTOPPED {
        local($t) = @_;
        eval "(($t)-> &t_state ==  &TS_STOPPED && !(($t)-> &t_schedflag &  &TS_RESUME))";
    }';
    eval 'sub VSTOPPED {
        local($t) = @_;
        eval "(($t)-> &t_proc_flag &  &TP_PRVSTOP)";
    }';
    eval 'sub CPR_VSTOPPED {
        local($t) = @_;
        eval "(($t)-> &t_state ==  &TS_SLEEP && ($t)-> &t_wchan0 && (($t)-> &t_flag &  &T_WAKEABLE) && (($t)-> &t_proc_flag &  &TP_CHKPT))";
    }';
    eval 'sub SUSPENDED {
        local($t) = @_;
        eval "(($t)-> &t_state ==  &TS_STOPPED && !(($t)-> &t_schedflag &  &TS_CSTART))";
    }';
    eval 'sub INHERITED {
        local($t) = @_;
        eval "(($t)-> &t_epri != 0)";
    }';
    eval 'sub DISP_PRIO {
        local($t) = @_;
        eval "( &INHERITED($t) ? ($t)-> &t_epri : ($t)-> &t_pri)";
    }';
    eval 'sub ASSIGNED_PRIO {
        local($t) = @_;
        eval "(($t)-> &t_pri)";
    }';
    eval 'sub SWAP_OK {
        local($t) = @_;
        eval "(! &LOCK_HELD(&($t)-> &t_lock))";
    }';
    eval 'sub proctot {
        local($x) = @_;
        eval "(($x)-> &p_tlist)";
    }';
    eval 'sub proctolwp {
        local($x) = @_;
        eval "(($x)-> &p_tlist-> &t_lwp)";
    }';
    eval 'sub ttolwp {
        local($x) = @_;
        eval "(($x)-> &t_lwp)";
    }';
    eval 'sub ttoproc {
        local($x) = @_;
        eval "(($x)-> &t_procp)";
    }';
    eval 'sub lwptot {
        local($x) = @_;
        eval "(($x)-> &lwp_thread)";
    }';
    eval 'sub lwptoproc {
        local($x) = @_;
        eval "(($x)-> &lwp_procp)";
    }';
    eval 'sub t_pc { &t_pcb. &val[0];}';
    eval 'sub t_sp { &t_pcb. &val[1];}';
    eval 'sub LWPCHAN {
        local($t) = @_;
        eval "(( &quad *)(&(($t)-> &t_wchan0)))";
    }';
    eval 'sub curthread {( &threadp());}';
    eval 'sub curproc {( &ttoproc( &curthread));}';
    eval 'sub thread_unlock {
        local($t) = @_;
        eval " &disp_lock_exit(($t)-> &t_lockp)";
    }';
    eval 'sub thread_unlock_high {
        local($t) = @_;
        eval " &disp_lock_exit_high(($t)-> &t_lockp)";
    }';
    eval 'sub thread_unlock_nopreempt {
        local($t) = @_;
        eval " &disp_lock_exit_nopreempt(($t)-> &t_lockp)";
    }';
    eval 'sub THREAD_LOCK_HELD {
        local($t) = @_;
        eval "( &DISP_LOCK_HELD(($t)-> &t_lockp))";
    }';
    eval 'sub THREAD_KPRI_REQUEST {
        eval "( &curthread-> &t_kpri_req++)";
    }';
    eval 'sub THREAD_KPRI_RELEASE {
        eval "( &curthread-> &t_kpri_req--)";
    }';
    eval 'sub THREAD_KPRI_RELEASE_N {
        local($n) = @_;
        eval "( &curthread-> &t_kpri_req -= ($n))";
    }';
    eval 'sub THREAD_SET_STATE {
        local($tp, $state, $lp) = @_;
        eval "(($tp)-> &t_state = $state, ($tp)-> &t_lockp = $lp)";
    }';
    eval 'sub THREAD_TRANSITION {
        local($tp) = @_;
        eval " &thread_transition($tp);";
    }';
    eval 'sub THREAD_TRANSITION_NOLOCK {
        local($tp) = @_;
        eval "(($tp)-> &t_lockp = & &transition_lock)";
    }';
    eval 'sub THREAD_RUN {
        local($tp, $lp) = @_;
        eval " &THREAD_SET_STATE($tp,  &TS_RUN, $lp)";
    }';
    eval 'sub THREAD_SWAP {
        local($tp, $lp) = @_;
        eval " &THREAD_SET_STATE($tp,  &TS_RUN, $lp)";
    }';
    eval 'sub THREAD_STOP {
        local($tp) = @_;
        eval "{  &disp_lock_t * &lp = ($tp)-> &t_lockp;  &THREAD_SET_STATE($tp,  &TS_STOPPED, & &stop_lock);  &disp_lock_exit( &lp); }";
    }';
    eval 'sub THREAD_ZOMB {
        local($tp) = @_;
        eval " &THREAD_SET_STATE($tp,  &TS_ZOMB,  &NULL)";
    }';
    eval 'sub THREAD_ONPROC {
        local($tp, $cpu) = @_;
        eval " &THREAD_SET_STATE($tp,  &TS_ONPROC, &($cpu)-> &cpu_thread_lock)";
    }';
    eval 'sub THREAD_SLEEP {
        local($tp, $lp) = @_;
        eval "{  &disp_lock_t * &tlp;  &tlp = ($tp)-> &t_lockp;  &THREAD_SET_STATE($tp,  &TS_SLEEP, $lp);  &disp_lock_exit_high( &tlp); }";
    }';
    if (defined &__cplusplus) {
    }
}
1;
