if (!defined &_SYS_WAIT_H) {
    eval 'sub _SYS_WAIT_H {1;}';
    require 'sys/feature_tests.ph';
    require 'sys/types.ph';
    if (!defined( &_POSIX_C_SOURCE) && !defined( &_XOPEN_SOURCE)) {
	require 'sys/siginfo.ph';
	require 'sys/procset.ph';
    }
    if (defined &__cplusplus) {
    }
    eval 'sub WUNTRACED {0004;}';
    eval 'sub WNOHANG {0100;}';
    if (!defined( &_POSIX_C_SOURCE) && !defined( &_XOPEN_SOURCE)) {
	eval 'sub WEXITED {0001;}';
	eval 'sub WTRAPPED {0002;}';
	eval 'sub WSTOPPED { &WUNTRACED;}';
	eval 'sub WCONTINUED {0010;}';
	eval 'sub WNOWAIT {0200;}';
	eval 'sub WOPTMASK {( &WEXITED| &WTRAPPED| &WSTOPPED| &WCONTINUED| &WNOHANG| &WNOWAIT);}';
    }
    if (!defined( &_POSIX_C_SOURCE) && !defined( &_XOPEN_SOURCE)) {
	eval 'sub WSTOPFLG {0177;}';
	eval 'sub WCONTFLG {0177777;}';
	eval 'sub WCOREFLG {0200;}';
	eval 'sub WSIGMASK {0177;}';
	eval 'sub WLOBYTE {
	    local($stat) = @_;
	    eval "((($stat)&0377))";
	}';
	eval 'sub WHIBYTE {
	    local($stat) = @_;
	    eval "(((($stat)>>8)&0377))";
	}';
	eval 'sub WWORD {
	    local($stat) = @_;
	    eval "((($stat))&0177777)";
	}';
	eval 'sub WIFCONTINUED {
	    local($stat) = @_;
	    eval "( &WWORD($stat) ==  &WCONTFLG)";
	}';
	eval 'sub WCOREDUMP {
	    local($stat) = @_;
	    eval "(($stat)& &WCOREFLG)";
	}';
    }
    eval 'sub WIFEXITED {
        local($stat) = @_;
        eval "((($stat)&0xFF) == 0)";
    }';
    eval 'sub WIFSIGNALED {
        local($stat) = @_;
        eval "((($stat)&0xFF) > 0 && (($stat)&0xFF00) == 0)";
    }';
    eval 'sub WIFSTOPPED {
        local($stat) = @_;
        eval "((($stat)&0xFF) == 0177 && (($stat)&0xFF00) != 0)";
    }';
    eval 'sub WEXITSTATUS {
        local($stat) = @_;
        eval "(((($stat)>>8)&0xFF))";
    }';
    eval 'sub WTERMSIG {
        local($stat) = @_;
        eval "((($stat)&0x7F))";
    }';
    eval 'sub WSTOPSIG {
        local($stat) = @_;
        eval "(((($stat)>>8)&0xFF))";
    }';
    if (!defined( &_KERNEL)) {
	if (defined( &__STDC__)) {
	    if (!defined( &_POSIX_C_SOURCE) && !defined( &_XOPEN_SOURCE)) {
	    }
	}
	else {
	    if (!defined( &_POSIX_C_SOURCE) && !defined( &_XOPEN_SOURCE)) {
	    }
	}
    }
    if (defined &__cplusplus) {
    }
}
1;
