if (!defined &_MACROS_H) {
    eval 'sub _MACROS_H {1;}';
    require 'sys/types.ph';
    require 'sys/stat.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub numeric {
        local($c) = @_;
        eval "(($c) >= ord(\'0\' && (c) <= \'9\'))";
    }';
    eval 'sub max {
        local($a, $b) = @_;
        eval "(($a) < ($b) ? ($b) : ($a))";
    }';
    eval 'sub min {
        local($a, $b) = @_;
        eval "(($a) > ($b) ? ($b) : ($a))";
    }';
    eval 'sub abs {
        local($x) = @_;
        eval "(($x) >= 0 ? ($x) : -($x))";
    }';
    eval 'sub compare {
        local($str1, $str2) = @_;
        eval " &strcmp(($str1), ($str2))";
    }';
    eval 'sub equal {
        local($str1, $str2) = @_;
        eval "( &strcmp(($str1), ($str2)) == 0)";
    }';
    eval 'sub length {
        local($str) = @_;
        eval " &strlen($str)";
    }';
    eval 'sub size {
        local($str) = @_;
        eval "( &strlen($str) + 1)";
    }';
    eval 'sub exists {
        local($file) = @_;
        eval "( &stat($file, & &Statbuf) < 0 ? 0 :  &Statbuf. &st_mode)";
    }';
    eval 'sub SAVE {
        local($name, $place) = @_;
        eval "{ \'int\' $place = $name;";
    }';
    eval 'sub RSTR {
        local($name, $place) = @_;
        eval "$name = $place; }";
    }';
    if (defined &__STDC__) {
	eval 'sub DEBUG {
	    local($var, $type) = @_;
	    eval " &fprintf( &stderr, #$var \\"= %\\" #$type \\"\\\\n\\", $var)";
	}';
	eval 'sub SCCSID {
	    local($arg) = @_;
	    eval " &static char  &Sccsid[] = #$arg";
	}';
    }
    else {
	eval 'sub DEBUG {
	    local($var, $type) = @_;
	    eval " &fprintf( &stderr, \\"var = %type\\\\n\\", $var)";
	}';
	eval 'sub SCCSID {
	    local($arg) = @_;
	    eval " &static char  &Sccsid[] = \\"arg\\"";
	}';
    }
    eval 'sub ERRABORT {
        eval " &_error() {  &abort(); }";
    }';
    eval 'sub NONBLANK {
        local($p) = @_;
        eval " &while (*($p) == ord(\' \' || *(p) == \'\\\\t\')) ($p)++";
    }';
    if (defined &__cplusplus) {
    }
}
1;
