if (!defined &_SYS_EMAP_H) {
    eval 'sub _SYS_EMAP_H {1;}';
    require 'sys/termios.ph';
    if (defined &__cplusplus) {
    }
    if ( &_KERNEL) {
	eval 'sub EMAP_STATE {
	    local($sp) = @_;
	    eval "(($sp)-> &es_state)";
	}';
	eval 'sub EMAP_SAVED_STATE {
	    local($sp) = @_;
	    eval "(($sp)-> &es_saved_state)";
	}';
	eval 'sub EMAP_FLAGS {
	    local($sp) = @_;
	    eval "(($sp)-> &es_flags)";
	}';
	eval 'sub EMAP_ERROR {
	    local($sp) = @_;
	    eval "(($sp)-> &es_error)";
	}';
	eval 'sub EMAP_SAVED {
	    local($sp) = @_;
	    eval "(($sp)-> &es_saved)";
	}';
	eval 'sub EMAP_EMAP {
	    local($sp) = @_;
	    eval "(($sp)-> &es_emap)";
	}';
	eval 'sub EMAP_MAP {
	    local($sp) = @_;
	    eval "( &EMAP_EMAP($sp)-> &e_map)";
	}';
	eval 'sub EMAP_NDIND {
	    local($sp) = @_;
	    eval "( &EMAP_EMAP($sp)-> &e_ndind)";
	}';
	eval 'sub EMAP_NCIND {
	    local($sp) = @_;
	    eval "( &EMAP_EMAP($sp)-> &e_ncind)";
	}';
	eval 'sub EMAP_NSIND {
	    local($sp) = @_;
	    eval "( &EMAP_EMAP($sp)-> &e_nsind)";
	}';
	eval 'sub ES_NULL {0x0;}';
	eval 'sub ES_OFF {0x1;}';
	eval 'sub ES_ON {0x2;}';
	eval 'sub ES_DEAD {(0x4 |  &ES_ON);}';
	eval 'sub ES_COMP1 {(0x8 |  &ES_ON);}';
	eval 'sub ES_COMP2 {(0x10 |  &ES_ON);}';
	eval 'sub ES_DEC {(0x20 |  &ES_ON);}';
	eval 'sub EF_NULL {0;}';
	eval 'sub EF_GOT_LDSMAP_DATA {1;}';
	eval 'sub EF_SCANCODE_RAW {2;}';
	eval 'sub EMAPPSZ { &INFPSZ;}';
    }
    eval 'sub EMBSHIFT {10;}';
    eval 'sub EMBMASK {01777;}';
    eval 'sub ESTRUCTOFF {
        local($structure, $field) = @_;
        eval " &((0)->$field)";
    }';
    eval 'sub E_DIND {( &ESTRUCTOFF( &emtab,  &e_dind[0]));}';
    eval 'sub EMAPED {ord(\'\\0\');}';
    eval 'sub EMAP_SIZE {1024;}';
    if (defined &__cplusplus) {
    }
}
1;
