if (!defined &_SYS_FS_UFS_FS_H) {
    eval 'sub _SYS_FS_UFS_FS_H {1;}';
    require 'sys/isa_defs.ph';
    require 'sys/t_lock.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub BBSIZE {8192;}';
    eval 'sub SBSIZE {8192;}';
    eval 'sub BBOFF {(( &off_t)(0));}';
    eval 'sub SBOFF {(( &off_t)( &BBOFF +  &BBSIZE));}';
    eval 'sub BBLOCK {(( &daddr_t)(0));}';
    eval 'sub SBLOCK {(( &daddr_t)( &BBLOCK +  &BBSIZE /  &DEV_BSIZE));}';
    eval 'sub UFSROOTINO {(( &ino_t)2);}';
    eval 'sub LOSTFOUNDINO {( &UFSROOTINO + 1);}';
    eval 'sub MINBSIZE {4096;}';
    eval 'sub MAXMNTLEN {512;}';
    eval 'sub MAXCSBUFS {32;}';
    eval 'sub FS_MAGIC {0x011954;}';
    eval 'sub FSOKAY {(0x7c269d38);}';
    eval 'sub FSACTIVE {(0);}';
    eval 'sub FSCLEAN {(0x1);}';
    eval 'sub FSSTABLE {(0x2);}';
    eval 'sub FSBAD {(0xff);}';
    eval 'sub FSSUSPEND {(0xfe);}';
    eval 'sub FSLOG {(0xfd);}';
    eval 'sub FSFIX {(0xfc);}';
    if (defined &_LITTLE_ENDIAN) {
    }
    else {
    }
    eval 'sub fs_reclaim { &fs_sparecon[53];}';
    if (defined &_LITTLE_ENDIAN) {
    }
    else {
    }
    eval 'sub FS_RECLAIM {(0x00000001);}';
    eval 'sub FS_RECLAIMING {(0x00000002);}';
    eval 'sub FS_CHECKCLEAN {(0x00000004);}';
    eval 'sub FS_CHECKRECLAIM {(0x00000008);}';
    eval 'sub FS_OPTTIME {0;}';
    eval 'sub FS_OPTSPACE {1;}';
    eval 'sub FS_42POSTBLFMT {-1;}';
    eval 'sub FS_DYNAMICPOSTBLFMT {1;}';
    if (defined &_KERNEL) {
	eval 'sub fs_postbl {
	    local($ufsvfsp, $cylno) = @_;
	    eval "((($ufsvfsp)-> &vfs_fs-> &fs_postblformat !=  &FS_DYNAMICPOSTBLFMT) ? (($ufsvfsp)-> &vfs_fs-> &fs_opostbl[$cylno]) : ((($ufsvfsp)-> &vfs_fs + ($ufsvfsp)-> &vfs_fs-> &fs_postbloff) + ($cylno) * ($ufsvfsp)-> &vfs_nrpos))";
	}';
    }
    else {
	eval 'sub fs_postbl {
	    local($fs, $cylno) = @_;
	    eval "((($fs)-> &fs_postblformat !=  &FS_DYNAMICPOSTBLFMT) ? (($fs)-> &fs_opostbl[$cylno]) : ((($fs) + ($fs)-> &fs_postbloff) + ($cylno) * ($fs)-> &fs_nrpos))";
	}';
    }
    eval 'sub fs_rotbl {
        local($fs) = @_;
        eval "((($fs)-> &fs_postblformat !=  &FS_DYNAMICPOSTBLFMT) ? (($fs)-> &fs_space) : ((($fs) + ($fs)-> &fs_rotbloff)))";
    }';
    eval 'sub fs_cs {
        local($fs, $indx) = @_;
        eval " &fs_csp[($indx) >> ($fs)-> &fs_csshift][($indx) & ~($fs)-> &fs_csmask]";
    }';
    eval 'sub CG_MAGIC {0x090255;}';
    eval 'sub cg_blktot {
        local($cgp) = @_;
        eval "((($cgp)-> &cg_magic !=  &CG_MAGIC) ? ((($cgp))-> &cg_btot) : ((($cgp) + ($cgp)-> &cg_btotoff)))";
    }';
    if (defined &_KERNEL) {
	eval 'sub cg_blks {
	    local($ufsvfsp, $cgp, $cylno) = @_;
	    eval "((($cgp)-> &cg_magic !=  &CG_MAGIC) ? ((($cgp))-> &cg_b[$cylno]) : ((($cgp) + ($cgp)-> &cg_boff) + ($cylno) * ($ufsvfsp)-> &vfs_nrpos))";
	}';
    }
    else {
	eval 'sub cg_blks {
	    local($fs, $cgp, $cylno) = @_;
	    eval "((($cgp)-> &cg_magic !=  &CG_MAGIC) ? ((($cgp))-> &cg_b[$cylno]) : ((($cgp) + ($cgp)-> &cg_boff) + ($cylno) * ($fs)-> &fs_nrpos))";
	}';
    }
    eval 'sub cg_inosused {
        local($cgp) = @_;
        eval "((($cgp)-> &cg_magic !=  &CG_MAGIC) ? ((($cgp))-> &cg_iused) : ((($cgp) + ($cgp)-> &cg_iusedoff)))";
    }';
    eval 'sub cg_blksfree {
        local($cgp) = @_;
        eval "((($cgp)-> &cg_magic !=  &CG_MAGIC) ? ((($cgp))-> &cg_free) : ((($cgp) + ($cgp)-> &cg_freeoff)))";
    }';
    eval 'sub cg_chkmagic {
        local($cgp) = @_;
        eval "(($cgp)-> &cg_magic ==  &CG_MAGIC || (($cgp))-> &cg_magic ==  &CG_MAGIC)";
    }';
    eval 'sub fsbtodb {
        local($fs, $b) = @_;
        eval "(($b) << ($fs)-> &fs_fsbtodb)";
    }';
    eval 'sub dbtofsb {
        local($fs, $b) = @_;
        eval "(($b) >> ($fs)-> &fs_fsbtodb)";
    }';
    eval 'sub cgbase {
        local($fs, $c) = @_;
        eval "(( &daddr_t)(($fs)-> &fs_fpg * ($c)))";
    }';
    eval 'sub cgstart {
        local($fs, $c) = @_;
        eval "( &cgbase($fs, $c) + ($fs)-> &fs_cgoffset * (($c) & ~(($fs)-> &fs_cgmask)))";
    }';
    eval 'sub cgsblock {
        local($fs, $c) = @_;
        eval "( &cgstart($fs, $c) + ($fs)-> &fs_sblkno)";
    }';
    eval 'sub cgtod {
        local($fs, $c) = @_;
        eval "( &cgstart($fs, $c) + ($fs)-> &fs_cblkno)";
    }';
    eval 'sub cgimin {
        local($fs, $c) = @_;
        eval "( &cgstart($fs, $c) + ($fs)-> &fs_iblkno)";
    }';
    eval 'sub cgdmin {
        local($fs, $c) = @_;
        eval "( &cgstart($fs, $c) + ($fs)-> &fs_dblkno)";
    }';
    eval 'sub itoo {
        local($fs, $x) = @_;
        eval "(($x) %  &INOPB($fs))";
    }';
    eval 'sub itog {
        local($fs, $x) = @_;
        eval "(($x) / ($fs)-> &fs_ipg)";
    }';
    eval 'sub itod {
        local($fs, $x) = @_;
        eval "(( &daddr_t)( &cgimin($fs,  &itog($fs, $x)) + ( &blkstofrags(($fs), ((($x)%($fs)-> &fs_ipg)/ &INOPB($fs))))))";
    }';
    eval 'sub dtog {
        local($fs, $d) = @_;
        eval "(($d) / ($fs)-> &fs_fpg)";
    }';
    eval 'sub dtogd {
        local($fs, $d) = @_;
        eval "(($d) % ($fs)-> &fs_fpg)";
    }';
    eval 'sub blkmap {
        local($fs, $map, $loc) = @_;
        eval "((($map)[($loc) /  &NBBY] >> (($loc) %  &NBBY)) & (0xff >> ( &NBBY - ($fs)-> &fs_frag)))";
    }';
    eval 'sub cbtocylno {
        local($fs, $bno) = @_;
        eval "(($bno) *  &NSPF($fs) / ($fs)-> &fs_spc)";
    }';
    if (defined &_KERNEL) {
	eval 'sub cbtorpos {
	    local($ufsvfsp, $bno) = @_;
	    eval "((((($bno) *  &NSPF(($ufsvfsp)-> &vfs_fs) % ($ufsvfsp)-> &vfs_fs-> &fs_spc) % ($ufsvfsp)-> &vfs_fs-> &fs_nsect) % ($ufsvfsp)-> &vfs_fs-> &fs_nsect) * ($ufsvfsp)-> &vfs_nrpos) / ($ufsvfsp)-> &vfs_fs-> &fs_nsect";
	}';
    }
    else {
	eval 'sub cbtorpos {
	    local($fs, $bno) = @_;
	    eval "((((($bno) *  &NSPF($fs) % ($fs)-> &fs_spc) % ($fs)-> &fs_nsect) % ($fs)-> &fs_nsect) * ($fs)-> &fs_nrpos) / ($fs)-> &fs_nsect";
	}';
    }
    eval 'sub blkoff {
        local($fs, $loc) = @_;
        eval "(($loc) & ~($fs)-> &fs_bmask)";
    }';
    eval 'sub fragoff {
        local($fs, $loc) = @_;
        eval "(($loc) & ~($fs)-> &fs_fmask)";
    }';
    eval 'sub lblkno {
        local($fs, $loc) = @_;
        eval "(($loc) >> ($fs)-> &fs_bshift)";
    }';
    eval 'sub numfrags {
        local($fs, $loc) = @_;
        eval "(($loc) >> ($fs)-> &fs_fshift)";
    }';
    eval 'sub blkroundup {
        local($fs, $size) = @_;
        eval "((($size) + ($fs)-> &fs_bsize - 1) & ($fs)-> &fs_bmask)";
    }';
    eval 'sub fragroundup {
        local($fs, $size) = @_;
        eval "((($size) + ($fs)-> &fs_fsize - 1) & ($fs)-> &fs_fmask)";
    }';
    eval 'sub fragstoblks {
        local($fs, $frags) = @_;
        eval "(($frags) >> ($fs)-> &fs_fragshift)";
    }';
    eval 'sub blkstofrags {
        local($fs, $blks) = @_;
        eval "(($blks) << ($fs)-> &fs_fragshift)";
    }';
    eval 'sub fragnum {
        local($fs, $fsb) = @_;
        eval "(($fsb) & (($fs)-> &fs_frag - 1))";
    }';
    eval 'sub blknum {
        local($fs, $fsb) = @_;
        eval "(($fsb) &~ (($fs)-> &fs_frag - 1))";
    }';
    eval 'sub freespace {
        local($fs, $percentreserved) = @_;
        eval "( &blkstofrags(($fs), ($fs)-> &fs_cstotal. &cs_nbfree) + ($fs)-> &fs_cstotal. &cs_nffree - (($fs)-> &fs_dsize / 100 * ($percentreserved)))";
    }';
    eval 'sub blksize {
        local($fs, $ip, $lbn) = @_;
        eval "((($lbn) >=  &NDADDR || ($ip)-> &i_size >= (($lbn) + 1) << ($fs)-> &fs_bshift) ? ($fs)-> &fs_bsize : ( &fragroundup($fs,  &blkoff($fs, ($ip)-> &i_size))))";
    }';
    eval 'sub dblksize {
        local($fs, $dip, $lbn) = @_;
        eval "((($lbn) >=  &NDADDR || ($dip)-> &di_size >= (($lbn) + 1) << ($fs)-> &fs_bshift) ? ($fs)-> &fs_bsize : ( &fragroundup($fs,  &blkoff($fs, ($dip)-> &di_size))))";
    }';
    eval 'sub NSPB {
        local($fs) = @_;
        eval "(($fs)-> &fs_nspf << ($fs)-> &fs_fragshift)";
    }';
    eval 'sub NSPF {
        local($fs) = @_;
        eval "(($fs)-> &fs_nspf)";
    }';
    eval 'sub INOPB {
        local($fs) = @_;
        eval "(($fs)-> &fs_inopb)";
    }';
    eval 'sub INOPF {
        local($fs) = @_;
        eval "(($fs)-> &fs_inopb >> ($fs)-> &fs_fragshift)";
    }';
    eval 'sub NINDIR {
        local($fs) = @_;
        eval "(($fs)-> &fs_nindir)";
    }';
    eval 'sub bitloc {
        local($a, $i) = @_;
        eval "(($a)[($i)/ &NBBY])";
    }';
    eval 'sub setbit {
        local($a, $i) = @_;
        eval "(($a)[($i)/ &NBBY] |= 1<<(($i)% &NBBY))";
    }';
    eval 'sub clrbit {
        local($a, $i) = @_;
        eval "(($a)[($i)/ &NBBY] &= ~(1<<(($i)% &NBBY)))";
    }';
    eval 'sub isset {
        local($a, $i) = @_;
        eval "(($a)[($i)/ &NBBY] & (1<<(($i)% &NBBY)))";
    }';
    eval 'sub isclr {
        local($a, $i) = @_;
        eval "((($a)[($i)/ &NBBY] & (1<<(($i)% &NBBY))) == 0)";
    }';
    eval 'sub getfs {
        local($vfsp) = @_;
        eval "(($vfsp-> &vfs_data)-> &vfs_bufp-> &b_un. &b_addr)";
    }';
    if (defined &__cplusplus) {
    }
}
1;
