if (!defined &_SYS_PROC_H) {
    eval 'sub _SYS_PROC_H {1;}';
    require 'sys/time.ph';
    require 'sys/thread.ph';
    require 'sys/cred.ph';
    require 'sys/user.ph';
    require 'sys/timer.ph';
    if (defined( &i386) || defined( &__i386)) {
	require 'sys/segment.ph';
    }
    if (defined &__cplusplus) {
    }
    if (defined( &i386) || defined( &__i386)) {
    }
    eval 'sub PROC_T {1;}';
    eval 'sub p_pgrp { &p_pgidp-> &pid_id;}';
    eval 'sub p_pid { &p_pidp-> &pid_id;}';
    eval 'sub p_slot { &p_pidp-> &pid_prslot;}';
    eval 'sub p_detached { &p_pgidp-> &pid_pgorphaned;}';
    eval 'sub PID_HOLD {
        local($pidp) = @_;
        eval " &ASSERT( &MUTEX_HELD(& &pidlock)); ++($pidp)-> &pid_ref;";
    }';
    eval 'sub PID_RELE {
        local($pidp) = @_;
        eval " &ASSERT( &MUTEX_HELD(& &pidlock)); ($pidp)-> &pid_ref > 1 ? --($pidp)-> &pid_ref :  &pid_rele($pidp);";
    }';
    eval 'sub p_lock { &p_lockp-> &pl_lock;}';
    eval 'sub SSLEEP {1;}';
    eval 'sub SRUN {2;}';
    eval 'sub SZOMB {3;}';
    eval 'sub SSTOP {4;}';
    eval 'sub SIDL {5;}';
    eval 'sub SONPROC {6;}';
    eval 'sub SSYS {0x00000001;}';
    eval 'sub STRC {0x00000002;}';
    eval 'sub SNWAKE {0x00000004;}';
    eval 'sub SLOAD {0x00000008;}';
    eval 'sub SLOCK {0x00000010;}';
    eval 'sub SPREXEC {0x00000020;}';
    eval 'sub SPROCTR {0x00000040;}';
    eval 'sub SPRFORK {0x00000080;}';
    eval 'sub SKILLED {0x00000100;}';
    eval 'sub SULOAD {0x00000200;}';
    eval 'sub SRUNLCL {0x00000400;}';
    eval 'sub SBPTADJ {0x00000800;}';
    eval 'sub SKILLCL {0x00001000;}';
    eval 'sub SOWEUPC {0x00002000;}';
    eval 'sub SEXECED {0x00004000;}';
    eval 'sub SPASYNC {0x00008000;}';
    eval 'sub SJCTL {0x00010000;}';
    eval 'sub SNOWAIT {0x00020000;}';
    eval 'sub SVFORK {0x00040000;}';
    eval 'sub SVFDONE {0x00080000;}';
    eval 'sub EXITLWPS {0x00100000;}';
    eval 'sub HOLDLWPS {0x00200000;}';
    eval 'sub SWAITSIG {0x00400000;}';
    eval 'sub HOLDLWP2 {0x00800000;}';
    eval 'sub COREDUMP {0x01000000;}';
    eval 'sub SMSACCT {0x02000000;}';
    eval 'sub ASLWP {0x04000000;}';
    eval 'sub SPRLOCK {0x08000000;}';
    eval 'sub NOCD {0x10000000;}';
    eval 'sub PTOU {
        local($p) = @_;
        eval "(&($p)-> &p_user)";
    }';
    eval 'sub tracing {
        local($p, $sig) = @_;
        eval "( &sigismember(&($p)-> &p_sigmask, $sig))";
    }';
    eval 'sub ISSIG {
        local($t, $why) = @_;
        eval " &ISSIG_FAST($t,  &ttolwp($t),  &ttoproc($t), $why)";
    }';
    eval 'sub ISSIG_FAST {
        local($t, $lwp, $p, $why) = @_;
        eval "( &ISSIG_PENDING($t, $lwp, $p) &&  &issig($why))";
    }';
    eval 'sub ISSIG_PENDING {
        local($t, $lwp, $p) = @_;
        eval "(($lwp)-> &lwp_cursig | ($p)-> &p_sig. &__sigbits[0] | ($p)-> &p_sig. &__sigbits[1] | ($t)-> &t_sig. &__sigbits[0] | ($t)-> &t_sig. &__sigbits[1] | ($p)-> &p_stopsig | (($t)-> &t_proc_flag & ( &TP_PRSTOP| &TP_CHKPT)) | (($p)-> &p_flag & ( &EXITLWPS| &SKILLED| &HOLDLWP2)))";
    }';
    eval 'sub ISSTOP {
        local($sig) = @_;
        eval "( &u. &u_signal[$sig-1] ==  &SIG_DFL &&  &sigismember(& &stopdefault, $sig))";
    }';
    eval 'sub ISHOLD {
        local($p) = @_;
        eval "((($p)-> &p_flag &  &HOLDLWPS) || ( &curthread-> &t_proc_flag &  &TP_HOLDLWP))";
    }';
    eval 'sub FORREAL {0;}';
    eval 'sub JUSTLOOKING {1;}';
    if (defined &_KERNEL) {
	if (defined( &i386) || defined( &__i386)) {
	}
    }
    if (defined &__cplusplus) {
    }
}
1;
