if (!defined &_SYS_TNF_WRITER_H) {
    eval 'sub _SYS_TNF_WRITER_H {1;}';
    require 'sys/types.ph';
    require 'sys/tnf_com.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub TNF_OFFSETOF {
        local($s, $m) = @_;
        eval "( &size_t)(&((($s *)0)->$m))";
    }';
    eval 'sub TNF_ALIGN {
        local($type) = @_;
        eval " &TNF_OFFSETOF(struct struct { \'char\'  &_c; $type  &_t; },  &_t)";
    }';
    eval 'sub TNF_TAG_VERSION {& &__tnf_tag_version_1;}';
    eval 'sub tnf_char {
        local($ops, $item, $ref) = @_;
        eval "($item)";
    }';
    eval 'sub tnf_int8 {
        local($ops, $item, $ref) = @_;
        eval "($item)";
    }';
    eval 'sub tnf_uint8 {
        local($ops, $item, $ref) = @_;
        eval "($item)";
    }';
    eval 'sub tnf_int16 {
        local($ops, $item, $ref) = @_;
        eval "($item)";
    }';
    eval 'sub tnf_uint16 {
        local($ops, $item, $ref) = @_;
        eval "($item)";
    }';
    eval 'sub tnf_int32 {
        local($ops, $item, $ref) = @_;
        eval "($item)";
    }';
    eval 'sub tnf_uint32 {
        local($ops, $item, $ref) = @_;
        eval "($item)";
    }';
    eval 'sub tnf_int64 {
        local($ops, $item, $ref) = @_;
        eval "($item)";
    }';
    eval 'sub tnf_uint64 {
        local($ops, $item, $ref) = @_;
        eval "($item)";
    }';
    eval 'sub tnf_float32 {
        local($ops, $item, $ref) = @_;
        eval "($item)";
    }';
    eval 'sub tnf_float64 {
        local($ops, $item, $ref) = @_;
        eval "($item)";
    }';
    eval 'sub tnf_uchar {
        local($ops, $item, $ref) = @_;
        eval " &tnf_uint8($ops, $item, $ref)";
    }';
    eval 'sub tnf_uchar_tag_data { &tnf_uint8_tag_data;}';
    eval 'sub tnf_short {
        local($ops, $item, $ref) = @_;
        eval " &tnf_int16($ops, $item, $ref)";
    }';
    eval 'sub tnf_short_tag_data { &tnf_int16_tag_data;}';
    eval 'sub tnf_ushort {
        local($ops, $item, $ref) = @_;
        eval " &tnf_uint16($ops, $item, $ref)";
    }';
    eval 'sub tnf_ushort_tag_data { &tnf_uint16_tag_data;}';
    eval 'sub tnf_long {
        local($ops, $item, $ref) = @_;
        eval " &tnf_int32($ops, $item, $ref)";
    }';
    eval 'sub tnf_long_tag_data { &tnf_int32_tag_data;}';
    eval 'sub tnf_ulong {
        local($ops, $item, $ref) = @_;
        eval " &tnf_uint32($ops, $item, $ref)";
    }';
    eval 'sub tnf_ulong_tag_data { &tnf_uint32_tag_data;}';
    eval 'sub tnf_longlong {
        local($ops, $item, $ref) = @_;
        eval " &tnf_int64($ops, $item, $ref)";
    }';
    eval 'sub tnf_longlong_tag_data { &tnf_int64_tag_data;}';
    eval 'sub tnf_ulonglong {
        local($ops, $item, $ref) = @_;
        eval " &tnf_uint64($ops, $item, $ref)";
    }';
    eval 'sub tnf_ulonglong_tag_data { &tnf_uint64_tag_data;}';
    eval 'sub tnf_float {
        local($ops, $item, $ref) = @_;
        eval " &tnf_float32($ops, $item, $ref)";
    }';
    eval 'sub tnf_float_tag_data { &tnf_float32_tag_data;}';
    eval 'sub tnf_double {
        local($ops, $item, $ref) = @_;
        eval " &tnf_float64($ops, $item, $ref)";
    }';
    eval 'sub tnf_double_tag_data { &tnf_float64_tag_data;}';
    eval 'sub tnf_ref32 {
        local($ops, $item, $ref) = @_;
        eval " &tnf_ref32_1($ops, $item, $ref)";
    }';
    eval 'sub tnf_tag {
        local($ops, $item, $ref) = @_;
        eval "( &tnf_ref32($ops, $item, $ref) |  &TNF_REF32_T_TAG)";
    }';
    eval 'sub tnf_string {
        local($ops, $item, $ref) = @_;
        eval " &tnf_string_1($ops, $item, $ref,  &tnf_string_tag_data)";
    }';
    eval 'sub tnf_name {
        local($ops, $item, $ref) = @_;
        eval " &tnf_string_1($ops, $item, $ref,  &tnf_name_tag_data)";
    }';
    eval 'sub tnf_size {
        local($ops, $item, $ref) = @_;
        eval " &tnf_uint32($ops, $item, $ref)";
    }';
    eval 'sub tnf_opaque {
        local($ops, $item, $ref) = @_;
        eval "(( &tnf_uint32_t)($item))";
    }';
    eval 'sub tnf_time_base {
        local($ops, $item, $ref) = @_;
        eval " &tnf_int64($ops, $item, $ref)";
    }';
    eval 'sub tnf_time_delta {
        local($ops, $item, $ref) = @_;
        eval " &tnf_uint32($ops, $item, $ref)";
    }';
    eval 'sub tnf_probe_event {
        local($ops, $item, $ref) = @_;
        eval "(( &tnf_ref32_t)($item) |  &TNF_REF32_T_PAIR)";
    }';
    eval 'sub tnf_pid {
        local($ops, $item, $ref) = @_;
        eval " &tnf_int32($ops, $item, $ref)";
    }';
    eval 'sub tnf_lwpid {
        local($ops, $item, $ref) = @_;
        eval " &tnf_uint32($ops, $item, $ref)";
    }';
    if (defined &_KERNEL) {
	eval 'sub tnf_kthread_id {
	    local($ops, $item, $ref) = @_;
	    eval " &tnf_opaque($ops, $item, $ref)";
	}';
	eval 'sub tnf_cpuid {
	    local($ops, $item, $ref) = @_;
	    eval " &tnf_int32($ops, $item, $ref)";
	}';
	eval 'sub tnf_device {
	    local($ops, $item, $ref) = @_;
	    eval " &tnf_uint32($ops, $item, $ref)";
	}';
	eval 'sub tnf_symbol {
	    local($ops, $item, $ref) = @_;
	    eval " &tnf_opaque($ops, $item, $ref)";
	}';
	eval 'sub tnf_symbols {
	    local($ops, $item, $ref) = @_;
	    eval " &tnf_opaque_array_1($ops, $item, $ref,  &tnf_symbols_tag_data)";
	}';
	eval 'sub tnf_sysnum {
	    local($ops, $item, $ref) = @_;
	    eval " &tnf_int32($ops, $item, $ref)";
	}';
	eval 'sub tnf_microstate {
	    local($ops, $item, $ref) = @_;
	    eval " &tnf_uint8($ops, $item, $ref)";
	}';
	eval 'sub tnf_offset {
	    local($ops, $item, $ref) = @_;
	    eval " &tnf_int64($ops, $item, $ref)";
	}';
	eval 'sub tnf_fault_type {
	    local($ops, $item, $ref) = @_;
	    eval " &tnf_uint8($ops, $item, $ref)";
	}';
	eval 'sub tnf_seg_access {
	    local($ops, $item, $ref) = @_;
	    eval " &tnf_uint8($ops, $item, $ref)";
	}';
	eval 'sub tnf_bioflags {
	    local($ops, $item, $ref) = @_;
	    eval " &tnf_int32($ops, $item, $ref)";
	}';
	eval 'sub tnf_diskaddr {
	    local($ops, $item, $ref) = @_;
	    eval " &tnf_int64($ops, $item, $ref)";
	}';
    }
    if (defined &_KERNEL) {
    }
    if (!defined( &_KERNEL) && !defined( &_TNF_LIBRARY)) {
    }
    if (defined &__cplusplus) {
    }
}
1;
